//
// JTypist v3.1 - Java typing tutor program for UNIX systems
// Copyright (C) 2000  Simon Baldwin (simonb@sco.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//
// ExerciseLesson class - defines the contents of an exercise lesson
//
import java.util.ResourceBundle;

/**
 * Exercise lesson is a type of Lesson, adding instructions.
 */
public abstract class ExerciseLesson extends Lesson {

	// additional exercise information
	private String		instructions;	// lesson instructions


	/**
	 * Lesson constructor.
	 *
	 * Deprecated as of version 3.1h.
	 */
	public ExerciseLesson( String title, String instructions,
			String text ) {
		super( title, text );
		this.instructions	= instructions;
	}

	/**
	 * Lesson constructor.
	 */
	public ExerciseLesson( String series_id, ResourceBundle resource,
			String name ) {
		super( series_id, resource, name );
	}


	/**
	 * Accessor method.
	 */
	public String get_instructions() {

		// return the instructions if we have it already
		if ( instructions != null )
			return ( instructions );

		// get the lesson instructions string, and if null then
		// make them be an empty string, and just carry on
		instructions = get_attribute( "instructions" );
		if ( instructions == null ) {
			instructions = "";
		}
		return ( instructions );
	}


	/**
	 * Printout method.
	 */
	public String toString() {
		return ( getClass().getName() + "{^" + super.toString()
				+ ",instructions=\"" + get_instructions()
				+ "\"}" );
	}
}
